

;;;pro eis_status_reformatter::determine_padding, packet_array, timing_data, padding, src, dest, lengths
function eis_status_reformatter::determine_padding, timing_data, pntrs
  self->trace, 'eis_status_reformatter::determine_padding'
  
  self->log, 'Calculating padding'
  
  self.n_gaps = 0
  self.n_samples_missing = 0
  padding = 0
  
                                ;n_ideal = n_elements(ideal)
  n_ideal = self.number_of_expected_packets
  n_actual = n_elements(packet_array)
  
  n_tdata = n_elements(timing_data)
  
;  rdata = packet_data
  
  interval = self.packet_interval_time ;2
                                ;seconds_per_period = 140
                                ;samples_per_period = seconds_per_period / interval
                                ;samples_per_period = self.number_of_expected_packets
  
  diffs = timing_data[1:n_tdata-1]-timing_data[0:n_tdata-2]
  n_diffs = n_elements(diffs)
  
  gsi = where(diffs gt (interval + (interval / 2)),count)
  n_gsi = n_elements(gsi)
  
;  if n_gsi eq 1 then begin
;     if gsi eq -1 then begin
;        padding = 0
;        return
;     endif
;  endif
  
  if count eq 0 then return, padding
  
  padding = 1
  
  gei = gsi + 1
  n_gei = n_elements(gei)
  
  gap_lengths = (diffs[gsi] / interval) - 1
  n_gap_lengths = n_elements(gap_lengths)
  
  missing_at_front = fix(timing_data[0] / interval)
  
  n_gaps = n_gap_lengths + 1
  self.n_gaps = n_gaps
  self.n_samples_missing = fix(total(gap_lengths) + missing_at_front)
  
  pntrs = intarr(4, n_gaps)
  pntrs[0,0] = 0
  pntrs[0,1:-1] = gei
  pntrs[1,0:-2] = gsi
  pntrs[1,n_gaps-1] = n_tdata - 1
  
  copy_lens = intarr(n_gaps)
  for i = 0, n_gaps - 1 do begin
     copy_lens[i] = pntrs[1,i] - pntrs[0,i] + 1
  endfor
  
  for i = 0, n_gaps - 1 do begin
     if i eq 0 then pntrs[2,i] = missing_at_front else pntrs[2,i] = pntrs[3,i-1] + gap_lengths[i-1] + 1
     pntrs[3,i] = pntrs[2,i] + copy_lens[i] - 1
  endfor
  
  self.n_gaps = n_gaps
  
  return, padding
  
;for i = 0, n_gaps - 1 do begin
;   rd_start = pntrs[0,i]
;   rd_end   = pntrs[1,i]
;   wr_start = pntrs[2,i]
;   wr_end   = pntrs[3,i]
;   pad[wr_start:wr_end] = tdata[rd_start:rd_end]
;endfor
  
  
;  diffs1 = diffs[1:n_diffs-1]-diffs[0:n_diffs-2]
;  li = where(diffs1 gt 0)

                                ; Each elemenmt of this array is the
                                ; number of packets missing in each gap
;  gap_lengths = diffs1[li] / interval

;  n_gap_lengths = n_elements(gap_lengths)

;  missing_at_front = fix(timing_data[0] / interval)

;missing_at_back = fix((ideal[n_ideal - 1] - tdata[n_tdata - 1]) / interval)
;; 3
;

;  src_start = 0
;  src_end   = n_diffs

;  n_gaps = n_elements(gap_lengths) + (missing_at_front gt 0)
;  self.n_gaps = n_gaps
;  self.n_samples_missing = fix(total(gap_lengths)) + missing_at_front
  
;;;n_gap_lengths = n_elements(gap_lengths)

;  gap_lengths1 = intarr(n_gap_lengths + 1)
;  gap_lengths1[0] = 0          ;missing_at_front                                                                                           
;  gap_lengths1[1:n_gap_lengths] = gap_lengths

;  src = intarr(n_gaps * 2)

;  src[0] = 0
;  src[-1] = n_diffs

;  for i = 0, n_elements(gsi) - 1 do src[i * 2 + 1] = gsi[i]
;  for i = 0, n_elements(gi)  - 1 do src[i * 2 + 2] = gi[i]

;  n_lengths = n_elements(src) / 2
;  lengths = intarr(n_lengths + 1)
;  for i = 0, n_lengths - 1 do lengths[i + 1] = src[i * 2 + 1] - src[i * 2] + 1
;  lengths[0] = 0

;  dest = intarr(n_gaps)
;  dest[0] = missing_at_front
;  for i = 1, n_gaps - 1 do dest[i] = dest[i - 1] + gap_lengths1[i] + lengths[i]

;  rd_ptrs = intarr(n_gaps)
;  for i = 0, n_gaps - 1 do rd_ptrs[i] = src[i * 2]

; now we have the read pointers (rd_ptrs), write pointers (dest) and
; lengths (lengths)

;  pad = fltarr(n_ideal, /nozero)
;  pad[*] = !VALUES.F_NAN
;
;;pad = make_array(n_ideal, /float, /value = !VALUES.NAN)
;
;  for i = 0 , n_gaps - 1 do pad[dest[i]:dest[i]+lengths[i+1]-1] = rdata[rd_ptrs[i]:rd_ptrs[i]+lengths[i+1]-1]

end

